/* -*- mode: C++; c-basic-offset: 2; -*- */
#if HAVE_CONFIG_H
#include "framecpp/config.h"
#endif /* HAVE_CONFIG_H */

#include <string.h>
#include <unistd.h>

#include <iostream>

#include "general/AtExit.hh"

#include "framecpp/Common/FrameSpec.hh"
#include "framecpp/Common/IOStream.hh"
#include "framecpp/Common/FrameStream.hh"
#include "framecpp/Common/FrTOC.hh"

#include "framecpp/Version4/FrTOC.hh"
#include "framecpp/Version6/FrTOC.hh"

#include "framecpp/FrameCPP.hh"

#include "toc.hh"

using namespace FrameCPP::Common;

using std::filebuf;

char* programname = 0;

int
main(int argc, char* argv[])
try
{
  /* Determine program name (strip filesystem path) */
  for (programname = argv [0] + strlen (argv [0]) - 1;
       programname != argv [0] && *programname != '/';
       programname--)
    ;
  
  if (*programname == '/')
  {
    programname++;
  }

  //---------------------------------------------------------------------
  // Parse arguments
  //---------------------------------------------------------------------
  int		args_parsed;
  
  for ( args_parsed = 1; args_parsed < argc; ++args_parsed )
  {
    char* cur_arg = argv[ args_parsed ];
	
    if ( strlen( cur_arg ) > 2 )
    {
#if 0
      if ( strncmp( cur_arg, "-c", 2 ) == 0 )
      {
	std::string	opt( &cur_arg[2] );

	// Convert to lower case
	for( std::string::iterator
	       cur = opt.begin( ),
	       last = opt.end( );
	     cur != last;
	     ++cur )
	{
	  *cur = tolower( *cur );
	}
	channel_set.insert( opt );
	create_test_frame = false;
      }
      else if ( strncmp( cur_arg, "-d", 2 ) == 0 )
      {
	// Specify the duration in seconds for the output data.
	deltat = atol( &(cur_arg[2]) );
	create_test_frame = false;
      }
      else if ( ! strncasecmp( cur_arg, "-h", 2 ) 
		|| ! strncasecmp( cur_arg, "--h", 3 ) )
      {
	usage( argv[0], 0 );
      }
      else if ( strncmp( cur_arg, "-i", 2 ) == 0 )
      {
	// Specify the number of iterations
	iterations = atol( &(cur_arg[2]) );
	create_test_frame = false;
      }
      else if ( strncmp( cur_arg, "-s", 2 ) == 0 )
      {
	// Specify the gps start time in whole seconds
	start = GPSTime( atol( &(cur_arg[2]) ), 0 );
	create_test_frame = false;
      }
      else if ( strncmp( cur_arg, "-t", 2 ) == 0 )
      {
	// Specify the gps start time in whole seconds
	type = &(cur_arg[2]);
	create_test_frame = false;
      }
      else if ( strncmp( cur_arg,
			 "--version=", sizeof( "--version=" ) - 1 )
		== 0 )
      {
	version = atol( &cur_arg[ sizeof( "--version=" ) - 1 ] );
      }
      else
      {
	break;
      }
    }
    else
    {
#endif /* WORKING */
      break;
    }
  }
  //---------------------------------------------------------------------
  // Process files
  //---------------------------------------------------------------------
  for ( ; args_parsed < argc; ++args_parsed )
  {
    char* filename = argv[ args_parsed ];
    //-------------------------------------------------------------------
    // Creation of the frame structure by reading of frame file
    //-------------------------------------------------------------------
    FrameBuffer< filebuf >*
      ibuf( new FrameBuffer< filebuf >( std::ios::in ) );
    
    ibuf->open( filename, std::ios::in | std::ios::binary );

    IFrameStream	ifs( ibuf, 0 );

    std::cout << "Frame file: " << filename << std::endl
	      << "Frame Specification: " << ifs.Version( ) << std::endl
      ;
    const FrTOC* toc( ifs.GetTOC( ) );

    dump( toc );
  }
  //---------------------------------------------------------------------
  // Exit
  //---------------------------------------------------------------------
  General::AtExit::Cleanup( );
}
catch( ... )
{
  General::AtExit::Cleanup( );
}
