#ifndef GENERAL__DIRECTORY
#define GENERAL__DIRECTORY

namespace General
{
  class Directory
  {
  public:
    /// Constructor
    Directory( const std::string& DirName, bool OpenDirectory = true );

    /// Destructor
    ~Directory( );

    void Close( );

    const char* const EntryName( ) const;

    int Fd( ) const;

    const std::string& Name( ) const;

    /// Retrieve the next entry.
    /// returns true if a valid entry was found, false otherwise
    bool Next( );

    void Open( );

  private:
    class Internals;

    Internals*	m_internals;
  };
}

#endif /* GENERAL__DIRECTORY */

